' Source File : FBD2HTM.Bas
' Object File : FBD2HTM.Exe
' Start Date  : 03/08/2013
' Author      : Ben Ritchey
' Description : Build HTML listing for Web from DESCRIPT.ION
'               with multi-line descriptions possible.
'               Copyright {c} 2013 by Ben Ritchey

  CLEAR ,,4096
  PRINT "FBD2HTM v1.2  (c) Ben Ritchey  Args=["+COMMAND$+"] "
  FBTITLE$=" ": FBDNAME$="00_INDEX.HTM"
  ON ERROR GOTO START
  OPEN "\FBD2HTM.INI" FOR INPUT AS #1
  ON ERROR GOTO NOINI
GETINI1:
  LINE INPUT#1,A$
  IF EOF(1) THEN GOTO NOINI
  IF A$="" THEN GOTO GETINI1
  IF A$<>"" AND MID$(A$,1,1)="#" THEN GOTO GETINI1
  FBDNAME$=A$
GETINI2:
  LINE INPUT#1,A$
  IF A$="" THEN GOTO GETINI2
  IF A$<>"" AND MID$(A$,1,1)="#" THEN GOTO GETINI2
  FBTITLE$=A$
NOINI:
  CLOSE #1 

START:
1000 ' PRINT
  ON ERROR GOTO INTERROR
    OPEN "DESCRIPT.ION" FOR INPUT AS #1
    OPEN FBDNAME$ FOR OUTPUT AS #2
    PRINT #2,"<HTML>"
    PRINT #2,"<HEAD>"
    PRINT #2,"<TITLE>"+FBTITLE$+"</TITLE>"
    PRINT #2,"</HEAD>"
    PRINT #2,"<A NAME="+CHR$(34)+"TOP"+CHR$(34)+"></A>"
    PRINT #2,"<BODY>"
    PRINT #2,"<CENTER>
    PRINT #2,"</CENTER>
    PRINT #2,"<TABLE border=1>"
    PRINT #2,"<CAPTION><H1><I><img src="+CHR$(34)+"/banner.png"+CHR$(34)+"></I></H1></CAPTION>"

    IF COMMAND$<>"" THEN
      PRINT #2,"<CAPTION><H2>";
      PRINT #2,"Directory of : ";
      PRINT #2,"<B>&nbsp;"+COMMAND$+"</B>";
      PRINT #2,"</H2></CAPTION>"
    ENDIF

    PRINT #2,"<TR><TH><FONT SIZE=4>File Name</TH>
    PRINT #2,"<TH><FONT SIZE=4>Modification_Date</TH>
    PRINT #2,"<TH><FONT SIZE=4>&nbsp;Size:Bytes</TH>
    PRINT #2,"<TH ALIGN=LEFT><FONT SIZE=4>&nbsp;Description</TH></FONT></TR>

    LINFLAG=2: DIRFLAG=0
SEARCH:
    IF EOF(1) THEN GOTO FINISHED
1010 LINE INPUT#1,A$

  IF A$="" THEN GOTO SEARCH
  IF MID$(A$,1)=SPACE$(LEN(A$)) THEN GOTO SEARCH
  CA=ASC(MID$(A$,1,1)): IF CA<32 OR CA>126 THEN GOTO SEARCH
1011
  IF A$=FBDNAME$ THEN GOTO SEARCH
  IF A$="FILES.FIX" THEN GOTO SEARCH
  IF A$="FBD2HTM.INI" THEN GOTO SEARCH
  IF A$="fbd2htm.ini" THEN GOTO SEARCH
  IF A$="00_index.htm" THEN GOTO SEARCH
  IF A$="00_INDEX.HTM" THEN GOTO SEARCH
  IF A$="DESCRIPT.ION" THEN GOTO SEARCH
  IF A$="descript.ion" THEN GOTO SEARCH

  IF FBTITLE$="The Positronium Repository" THEN
    IF A$="Crossovers" THEN GOTO SEARCH
    IF LEN(A$)>6 THEN IF MID$(A$,1,7)="SIMTEL_" THEN GOTO SEARCH
    IF A$="pdsl95.cd" THEN GOTO SEARCH
  ENDIF

  IF MID$(A$,1,1)=" " THEN GOTO APPDESC
  'VL=INSTR(1,A$,".")
  'IF VL=0 OR VL>9 THEN GOTO APPDESC
1012
  IF LINFLAG<2 THEN
  IF S$<>"" THEN
    FOR LC=1 TO LEN(S$)
      CA=ASC(MID$(S$,LC,1))
      IF CA<32 OR CA>126 THEN MID$(S$,LC,1)=" "
    NEXT LC
  ENDIF
1013
    PRINT #2,"<TD><B><FONT SIZE=3 FACE=Cambria,Georgia>"+S$+"</TD>";
    PRINT #2,"</FONT></B></TR>": S$="": LINFLAG=2
  ENDIF

  FLNAME$=MID$(A$,1,12): A$=MID$(A$,13)
  FOR NI=LEN(FLNAME$) TO 2 STEP -1
    IF MID$(FLNAME$,NI,1)=" " THEN FLNAME$=MID$(FLNAME$,1,NI-1)
  NEXT NI  
'  S0$="": FOR VI=1 TO 14-LEN(FLNAME$): S0$=S0$+"&nbsp;": NEXT VI

  PRINT #2,"<TR><TD><FONT SIZE=3 FACE=Helvetica,Georgia><B><A HREF="+CHR$(34);
  PRINT #2,FLNAME$+CHR$(34)+">"+FLNAME$+"</A></FONT></TD>"

  SHELL "DIR "+FLNAME$+" > \DIR1"
  OPEN "\DIR1" FOR INPUT AS #3
  DREC$="-": DTE$="> not found <"
FINDIT:
  FOR FL=1 TO 6
  IF EOF(3) THEN 
    LET FL=6
   ELSE LINE INPUT#3,D$
  ENDIF
  NEXT FL
'PRINT D$
  IF D$="" GOTO GO4IT
  IF MID$(D$,1)=SPACE$(LEN(D$)) THEN GOTO GO4IT

  FLNME$=MID$(D$,1,12): IF MID$(FLNME$,10,3)<>"   " THEN MID$(FLNME$,9,1)="."
LOOPSP:
  SL=INSTR(FLNME$," "): IF SL=0 GOTO GOTNOSP
  FLNME$=MID$(FLNME$,1,SL-1)+MID$(FLNME$,SL+1)
  GOTO LOOPSP
GOTNOSP:
  FOR CL=1 TO LEN(FLNAME$)
  IF ASC(MID$(FLNAME$,CL,1))>96 AND ASC(MID$(FLNAME$,CL,1))<123 THEN
    MID$(FLNAME$,CL,1)=CHR$(ASC(MID$(FLNAME$,CL,1))-32)
  ENDIF
  NEXT CL
  IF FLNME$=FLNAME$ THEN
    DTE$=MID$(D$,24,16)+"m"
    DREC$=STR$(VAL(MID$(D$,13,10))):DREC$=MID$(SPACE$(10),1,10-LEN(DREC$))+DREC$
  ENDIF
  IF MID$(D$,14,5)="<DIR>" THEN
    DIRFLAG=1
    DTE$=MID$(D$,24,16)+"m"
    DREC$="<img src="+CHR$(34)+"/icons/dir.png"+CHR$(34)+">"
  ENDIF
GO4IT:
  CLOSE #3
  IF MID$(DTE$,10,1)=" " THEN DTE$=MID$(DTE$,1,9)+"&nbsp;"+MID$(DTE$,11)
  PRINT #2,"<TD ALIGN=LEFT>"+DTE$+"</TD>";
  IF DIRFLAG=0 AND DREC$<>"-" THEN
    IF MID$(DREC$,1,1)<>" " THEN DRCOMMA1$="," ELSE DRCOMMA1$=" "
    IF MID$(DREC$,4,1)<>" " THEN DRCOMMA2$="," ELSE DRCOMMA2$=" "
    IF MID$(DREC$,7,1)<>" " THEN DRCOMMA3$="," ELSE DRCOMMA3$=" "
    PRINT #2,"<TD ALIGN=RIGHT>";
    PRINT #2,MID$(DREC$,1,1)+DRCOMMA1$+MID$(DREC$,2,3)+DRCOMMA2$;
    PRINT #2,MID$(DREC$,5,3)+DRCOMMA3$+MID$(DREC$,8,3)+"</TD>
   ELSE
    IF DIRFLAG=1 THEN
      PRINT #2,"<TD ALIGN=LEFT>"+DREC$+"</TD>"
     ELSE
      PRINT #2,"<TD ALIGN=RIGHT>"+DREC$+"</TD>"
    ENDIF
  ENDIF

  LINFLAG=1
  Z$=FLNAME$: GOSUB MESSAGE

APPDESC:

'  IF MID$(A$,1,21)="  " THEN 
'    FOR TI=1 TO LEN(A$)
'      IF MID$(A$,1,1)=" " THEN
'        A$=MID$(A$,2): TI=TI-1
'        IF A$=" " THEN TI=LEN(A$)
'       ELSE TI=LEN(A$)
'      ENDIF
'    NEXT TI
'  ENDIF  

  S$=S$+A$
  LINFLAG=0: DIRFLAG=0
  Z$=A$: GOSUB MESSAGE
  GOTO SEARCH

  ERROR 123: REM Error Trap {Next line should NEVER be executed ...}
  GOTO FINISHED
5000 REM

PROGLOG:
  IF SYSLOG THEN PRINT #3, Z$
  RETURN
PROMPT:
  COLOR 7: PRINT Z$;: COLOR 15: INPUT A$
  IF SYSLOG THEN PRINT #3, Z$: PRINT #3, A$
  COLOR 3: RETURN

MESSAGE:
  RETURN

  IF SYSLOG THEN PRINT #3, Z$
  PRINT Z$: RETURN

INTERROR:
  A=ERR: B=ERL: C=ERDEV
10000 PRINT
  SOUND 800, 4: SOUND 400, 2: SOUND 800, 8
  COLOR 14
  PRINT "  Internal Error";A;"  Line";B;"  Dev";C;" ";ERDEV$;" <Return>";
  A$="": WHILE A$="": A$=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  SOUND 1000,2
  PRINT "Ok": A$="": WHILE A$="": A$=INKEY$: WEND
' *** Debug

FINISHED:
99999 'COLOR 7: PRINT
'  Z$ = "": A = 0
  PRINT #2,"<TD><B><FONT SIZE=3 FACE=Cambria,Georgia>"+S$+"</TD></FONT></B></TR>"
'  PRINT "  Touch any key to Abort one minute Window"
'  WHILE Z$ = "" AND TIMER < TIMEOUT
'    Z$ = INKEY$
'    IF TIMER >= A + 1 THEN LET A = TIMER: PRINT INT(TIMEOUT - A);
'  WEND
'  PRINT : PRINT
rem  PRINT #2,""
  PRINT #2,"</FONT></TABLE><BR><P><A HREF="+CHR$(34)+"#TOP";
  PRINT #2,CHR$(34)+">Back to TOP</A>"
  PRINT #2,"<BR><P><LEFT>"
  PRINT #2,"<FONT FACE=Cambria,Georgia SIZE=3>Generated by &nbsp;";
  PRINT #2,"FBD2HTM&nbsp; &copy; 2013 Ben Ritchey aka cMech with "
  PRINT #2,"&nbsp;<A HREF="+CHR$(34)+"http://cmech.dynip.com"+CHR$(34)+">"
  PRINT #2,"The Positronium Repository</A> &nbsp;as of &nbsp;";
  PRINT #2,DATE$+"</FONT><BR></LEFT>"
  PRINT #2,"<HR><HR><BR><P></BODY>"
  PRINT #2,"</HTML>"

  CLOSE
'Z$="SYSTEM command next...ENTER": GOSUB PROMPT
  SYSTEM

REM Month Table Data
  DATA January, February, March, April, May, June
  DATA July, August, September, October, November, December
  DATA Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec
REM *** End of FixBFDS.Bas ***

